package com.ajja.service.bootstrap.common.impl.spring.boot.sql;

import com.ajja.service.bootstrap.common.application.sql.IPreparedStatement;
import com.ajja.service.bootstrap.common.application.sql.ISQLConnection;
import com.ajja.service.bootstrap.common.application.sql.exception.SQLException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.sql.DataSource;
import java.sql.Connection;

@Component
public class SQLConnectionImpl implements ISQLConnection {

    @Autowired
    private DataSource dataSource;

    @Override
    public IPreparedStatement prepareStatement(String sql) throws SQLException {
        try {
            final Connection connection = dataSource.getConnection();
            return new PreparedStatementImpl(connection, sql);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }

    @Override
    public IPreparedStatement prepareStatement(String sql, int autoGeneratedKeys) throws SQLException {
        try {
            final Connection connection = dataSource.getConnection();
            return new PreparedStatementImpl(connection, sql, autoGeneratedKeys);
        } catch (java.sql.SQLException e) {
            throw new SQLException(e);
        }
    }
}
